searchData={"items":[{"type":"module","title":"Unfurl","doc":"Unfurl is a [structured data](https://moz.com/learn/seo/schema-structured-data) extraction tool written in Elixir.\n\nIt currently supports unfurling oEmbed, Open Graph (Facebook), Twitter Card, JSON-LD, rel-me, favicons, and plain ole' HTML ` ` data out of any url you supply.","ref":"Unfurl.html"},{"type":"module","title":"Installation - Unfurl","doc":"Add `:unfurl` to your list of dependencies in `mix.exs`:O\n\n```elixir\ndef deps do\n  [{:unfurl, \"~> 0.6.0\"}]\nend\n```\n\nThen run `$ mix deps.get`. Also add `:unfurl` to your applications list:\n\n```elixir\ndef application do\n  [applications: [:unfurl]]\nend\n```\n\n[Jason](http://github.com/michalmuskala/jason) is the default json library in Unfurl. You can however configure Unfurl to use another library. For example:\n\n```elixir\nconfig :unfurl, :json_library, YourLibraryOfChoice\n```","ref":"Unfurl.html#module-installation"},{"type":"module","title":"Usage - Unfurl","doc":"To unfurl a url, simply pass it to `Unfurl.unfurl/1`\n\n```elixir\niex(1)> Unfurl.unfurl \"https://www.youtube.com/watch?v=Gh6H7Md_L2k\"\n{:ok,\n %{\n   other: %{\n     \"description\" => \"Ask This Old House host Kevin O’Connor visits Nick Offerman in Los Angeles to tour the comedian’s woodworking shop.SUBSCRIBE to This Old House: http://bit.ly...\",\n     \"keywords\" => \"this old house, how-to, home improvement, Episode, TV Show, DIY, Ask This Old House, Nick Offerman, Kevin O'Connor, woodworking, wood shop, Los Angeles, Comedian, This Old House, Home Improvement, DIY Ideas, Renovation, Renovation Ideas, How To Fix, How To Install, How To Build, Kevin o’connor, kevin o'connor house, kevin o'connor this old house, kevin o'connor ask this old house, kevin o'connor interview\",\n     \"theme-color\" => \"rgba(255, 255, 255, 0.98)\",\n     \"title\" => [\"Touring Nick Offerman’s Wood Shop | Ask This Old House\",\n      \"Touring Nick Offerman’s Wood Shop | Ask This Old House - YouTube\"]\n   },\n   canonical_url: nil,\n   facebook: %{\n     \"description\" => \"Ask This Old House host Kevin O’Connor visits Nick Offerman in Los Angeles to tour the comedian’s woodworking shop.SUBSCRIBE to This Old House: http://bit.ly...\",\n     \"fb\" => %{\"app_id\" => \"87741124305\"},\n     \"image\" => %{\"height\" => \"720\", \"width\" => \"1280\"},\n     \"site_name\" => \"YouTube\",\n     \"title\" => \"Touring Nick Offerman’s Wood Shop | Ask This Old House\",\n     \"type\" => \"video.other\",\n     \"url\" => \"https://www.youtube.com/watch?v=Gh6H7Md_L2k\",\n     \"video\" => %{\n       \"height\" => \"720\",\n       \"secure_url\" => \"https://www.youtube.com/embed/Gh6H7Md_L2k\",\n       \"type\" => \"text/html\",\n       \"url\" => \"https://www.youtube.com/embed/Gh6H7Md_L2k\",\n       \"width\" => \"1280\"\n     }\n   },\n   twitter: %{\n     \"app\" => %{\n       \"id\" => %{\n         \"googleplay\" => \"com.google.android.youtube\",\n         \"ipad\" => \"544007664\",\n         \"iphone\" => \"544007664\"\n       },\n       \"name\" => %{\n         \"googleplay\" => \"YouTube\",\n         \"ipad\" => \"YouTube\",\n         \"iphone\" => \"YouTube\"\n       },\n       \"url\" => %{\n         \"googleplay\" => \"https://www.youtube.com/watch?v=Gh6H7Md_L2k\",\n         \"ipad\" => \"vnd.youtube://www.youtube.com/watch?v=Gh6H7Md_L2k&feature=applinks\",\n         \"iphone\" => \"vnd.youtube://www.youtube.com/watch?v=Gh6H7Md_L2k&feature=applinks\"\n       }\n     },\n     \"card\" => \"player\",\n     \"description\" => \"Ask This Old House host Kevin O’Connor visits Nick Offerman in Los Angeles to tour the comedian’s woodworking shop.SUBSCRIBE to This Old House: http://bit.ly...\",\n     \"image\" => \"https://i.ytimg.com/vi/Gh6H7Md_L2k/maxresdefault.jpg\",\n     \"player\" => %{\"height\" => \"720\", \"width\" => \"1280\"},\n     \"site\" => \"@youtube\",\n     \"title\" => \"Touring Nick Offerman’s Wood Shop | Ask This Old House\",\n     \"url\" => \"https://www.youtube.com/watch?v=Gh6H7Md_L2k\"\n   },\n   oembed: %{\n     \"author_name\" => \"This Old House\",\n     \"author_url\" => \"https://www.youtube.com/@thisoldhouse\",\n     \"height\" => 113,\n     \"html\" => \"  \",\n     \"provider_name\" => \"YouTube\",\n     \"provider_url\" => \"https://www.youtube.com/\",\n     \"thumbnail_height\" => 360,\n     \"thumbnail_url\" => \"https://i.ytimg.com/vi/Gh6H7Md_L2k/hqdefault.jpg\",\n     \"thumbnail_width\" => 480,\n     \"title\" => \"Touring Nick Offerman’s Wood Shop | Ask This Old House\",\n     \"type\" => \"video\",\n     \"version\" => \"1.0\",\n     \"width\" => 200\n   },\n   json_ld: [\n     %{\n       \"@context\" => \"http://schema.org\",\n       \"@type\" => \"BreadcrumbList\",\n       \"itemListElement\" => [\n         %{\n           \"@type\" => \"ListItem\",\n           \"item\" => %{\n             \"@id\" => \"http://www.youtube.com/@thisoldhouse\",\n             \"name\" => \"This Old House\"\n           },\n           \"position\" => 1\n         }\n       ]\n     }\n   ],\n   status_code: 200,\n   rel_me: nil,\n   favicon: \"https://www.youtube.com/s/desktop/ef8ce500/img/favicon_32x32.png\"\n }}\n```","ref":"Unfurl.html#module-usage"},{"type":"module","title":"Configuration - Unfurl","doc":"Unfurl accepts a few optional configuration parameters.\n\nYou may configure additional tags to capture under the Facebook\nOpenGraph and TwitterCard parsers.\n\n```elixir\nconfig :unfurl, Unfurl.Parser.Facebook,\n  tags: ~w(my:custom:facebook:tag another:custom:facebook:tag)\n\nconfig :unfurl, Unfurl.Parser.Twitter,\n  tags: ~w(my:custom:twitter:tag)\n```\n\nYou may also configure the depth of the resulting Unfurl map with a `:group_keys?` boolean.\n\n```elixir\nconfig :unfurl, group_keys?: true\n```\n\nIf this option is set to false or unconfigured, Unfurl will return values mapped directly beneath OpenGraph and TwitterCard keys, i.e.\n\n```elixir\n%{twitter: %{\n  \"twitter:app:id:googleplay\" => \"com.google.android.youtube\",\n  \"twitter:app:id:ipad\"       => \"544007664\",\n  \"twitter:app:id:iphone\"     => \"544007664\"\n}}\n```\n\nIf true, Unfurl will return values grouped into colon-delimited map structures, i.e.\n\n```elixir\n%{twitter: %{\n  \"twitter\" => %{\n    \"app\" => %{\n      \"id\" => %{\n        \"googleplay\" => \"com.google.android.youtube\",\n        \"ipad\"       => \"544007664\",\n        \"iphone\"     => \"544007664\"\n      }\n    }\n  }\n}}\n```","ref":"Unfurl.html#module-configuration"},{"type":"module","title":"License - Unfurl","doc":"Copyright 2020 Bonfire Networks\nCopyright 2017 Clayton Gentry (author of https://www.hex.pm/packages/furlex which Unfurl was forked from)\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n```\nhttp://www.apache.org/licenses/LICENSE-2.0`\n```\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"Unfurl.html#module-license"},{"type":"function","title":"Unfurl.maybe_favicon/2","doc":"","ref":"Unfurl.html#maybe_favicon/2"},{"type":"function","title":"Unfurl.unfurl/2","doc":"Unfurls a url\n\nFetches oembed data if available, as well as the source HTML to be parsed by `unfurl_html/3`.\n\nAlso accepts opts as a keyword list.","ref":"Unfurl.html#unfurl/2"},{"type":"function","title":"Unfurl.unfurl_html/3","doc":"Extracts data from the pre-fetched HTML source of a URL\n\nChecks for Twitter Card, Open Graph, JSON-LD, rel-me, and other HTML meta tags.\n\nAlso tries to find and/or fetch (disable all with `skip_fetches: true`):\n- a favicon (disable with `skip_favicon_fetch: true`)\n- oembed info (disable with `skip_oembed_fetch: true`)","ref":"Unfurl.html#unfurl_html/3"},{"type":"module","title":"Unfurl.Fetcher","doc":"A module for fetching body data for a given url","ref":"Unfurl.Fetcher.html"},{"type":"function","title":"Unfurl.Fetcher.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#delete/3"},{"type":"function","title":"Unfurl.Fetcher.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#delete!/3"},{"type":"function","title":"Unfurl.Fetcher.fetch/2","doc":"Fetches a url and extracts the body","ref":"Unfurl.Fetcher.html#fetch/2"},{"type":"function","title":"Unfurl.Fetcher.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#get/3"},{"type":"function","title":"Unfurl.Fetcher.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#get!/3"},{"type":"function","title":"Unfurl.Fetcher.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#head/3"},{"type":"function","title":"Unfurl.Fetcher.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#head!/3"},{"type":"function","title":"Unfurl.Fetcher.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#options/3"},{"type":"function","title":"Unfurl.Fetcher.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#options!/3"},{"type":"function","title":"Unfurl.Fetcher.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Unfurl.Fetcher.html#patch/4"},{"type":"function","title":"Unfurl.Fetcher.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Unfurl.Fetcher.html#patch!/4"},{"type":"function","title":"Unfurl.Fetcher.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Unfurl.Fetcher.html#post/4"},{"type":"function","title":"Unfurl.Fetcher.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Unfurl.Fetcher.html#post!/4"},{"type":"function","title":"Unfurl.Fetcher.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Unfurl.Fetcher.html#put/4"},{"type":"function","title":"Unfurl.Fetcher.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Unfurl.Fetcher.html#put!/4"},{"type":"function","title":"Unfurl.Fetcher.request/2","doc":"Perform a request.","ref":"Unfurl.Fetcher.html#request/2"},{"type":"function","title":"Options - Unfurl.Fetcher.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"Unfurl.Fetcher.html#request/2-options"},{"type":"function","title":"Examples - Unfurl.Fetcher.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#request/2-examples"},{"type":"function","title":"Unfurl.Fetcher.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"Unfurl.Fetcher.html#request!/2"},{"type":"function","title":"Unfurl.Fetcher.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#trace/3"},{"type":"function","title":"Unfurl.Fetcher.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Unfurl.Fetcher.html#trace!/3"},{"type":"type","title":"Unfurl.Fetcher.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"Unfurl.Fetcher.html#t:option/0"},{"type":"module","title":"Unfurl.Oembed","doc":"A module for managing oembed data","ref":"Unfurl.Oembed.html"},{"type":"function","title":"Unfurl.Oembed.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Unfurl.Oembed.html#child_spec/1"},{"type":"function","title":"Unfurl.Oembed.detect_and_fetch/3","doc":"Looks for an oembed link in the HTML of the given url and fetches it","ref":"Unfurl.Oembed.html#detect_and_fetch/3"},{"type":"function","title":"Unfurl.Oembed.endpoint_from_html/1","doc":"","ref":"Unfurl.Oembed.html#endpoint_from_html/1"},{"type":"function","title":"Unfurl.Oembed.endpoint_from_url/3","doc":"Returns an Oembed endpoint for the given url","ref":"Unfurl.Oembed.html#endpoint_from_url/3"},{"type":"function","title":"Examples - Unfurl.Oembed.endpoint_from_url/3","doc":"iex> Oembed.endpoint_from_url \"https://vimeo.com/88856141\"\n  {:ok, \"https://vimeo.com/api/oembed.json\"}\n\n    iex> Oembed.endpoint_from_url \"https://vimeo.com/88856141\", %{\"format\" => \"xml\"}\n  {:ok, \"https://vimeo.com/api/oembed.xml\"}","ref":"Unfurl.Oembed.html#endpoint_from_url/3-examples"},{"type":"function","title":"Unfurl.Oembed.fetch/2","doc":"Fetches oembed data for the given url *if* it comes from a known provider","ref":"Unfurl.Oembed.html#fetch/2"},{"type":"function","title":"Unfurl.Oembed.fetch_providers/1","doc":"Fetches the list of Oembed providers\n\nSoft fetch will fetch cached providers. Hard fetch requests\nproviders from oembed.com and purges the cache.","ref":"Unfurl.Oembed.html#fetch_providers/1"},{"type":"function","title":"Unfurl.Oembed.init/1","doc":"","ref":"Unfurl.Oembed.html#init/1"},{"type":"function","title":"Unfurl.Oembed.process_url/1","doc":"","ref":"Unfurl.Oembed.html#process_url/1"},{"type":"behaviour","title":"Unfurl.Parser","doc":"","ref":"Unfurl.Parser.html"},{"type":"function","title":"Unfurl.Parser.extract/4","doc":"Extracts the given tags from the given raw html according to\nthe given match function","ref":"Unfurl.Parser.html#extract/4"},{"type":"function","title":"Unfurl.Parser.extract_canonical/1","doc":"Extracts a canonical url from the given raw HTML","ref":"Unfurl.Parser.html#extract_canonical/1"},{"type":"function","title":"Unfurl.Parser.maybe_group_keys/1","doc":"Groups colon-separated keys into dynamic map structures","ref":"Unfurl.Parser.html#maybe_group_keys/1"},{"type":"function","title":"Examples - Unfurl.Parser.maybe_group_keys/1","doc":"iex> Application.put_env(:unfurl, :group_keys?, false)\n    iex> Unfurl.Parser.maybe_group_keys %{\"twitter:app:id\" => 123, \"twitter:app:name\" => \"YouTube\"}\n    %{\"twitter:app:id\" => 123, \"twitter:app:name\" => \"YouTube\"}\n\n    iex> Application.put_env(:unfurl, :group_keys?, true)\n    iex> Unfurl.Parser.maybe_group_keys %{\"twitter:app:id\" => 123, \"twitter:app:name\" => \"YouTube\"}\n    %{\n      \"twitter\" => %{\n        \"app\" => %{\n          \"id\" => 123,\n          \"name\" => \"YouTube\"\n        }\n      }\n    }","ref":"Unfurl.Parser.html#maybe_group_keys/1-examples"},{"type":"callback","title":"Unfurl.Parser.parse/1","doc":"Parses the given HTML, returning a map structure of structured\ndata keys mapping to their respective values, or an error.","ref":"Unfurl.Parser.html#c:parse/1"},{"type":"module","title":"Unfurl.Parser.Facebook","doc":"","ref":"Unfurl.Parser.Facebook.html"},{"type":"function","title":"Unfurl.Parser.Facebook.parse/2","doc":"","ref":"Unfurl.Parser.Facebook.html#parse/2"},{"type":"function","title":"Unfurl.Parser.Facebook.tags/0","doc":"","ref":"Unfurl.Parser.Facebook.html#tags/0"},{"type":"module","title":"Unfurl.Parser.HTML","doc":"","ref":"Unfurl.Parser.HTML.html"},{"type":"function","title":"Unfurl.Parser.HTML.parse/2","doc":"","ref":"Unfurl.Parser.HTML.html#parse/2"},{"type":"module","title":"Unfurl.Parser.JsonLD","doc":"","ref":"Unfurl.Parser.JsonLD.html"},{"type":"function","title":"Unfurl.Parser.JsonLD.parse/2","doc":"","ref":"Unfurl.Parser.JsonLD.html#parse/2"},{"type":"module","title":"Unfurl.Parser.RelMe","doc":"","ref":"Unfurl.Parser.RelMe.html"},{"type":"function","title":"Unfurl.Parser.RelMe.parse/2","doc":"","ref":"Unfurl.Parser.RelMe.html#parse/2"},{"type":"module","title":"Unfurl.Parser.Twitter","doc":"","ref":"Unfurl.Parser.Twitter.html"},{"type":"function","title":"Unfurl.Parser.Twitter.parse/2","doc":"","ref":"Unfurl.Parser.Twitter.html#parse/2"},{"type":"extras","title":"Unfurl","doc":"# Unfurl\n\nUnfurl is a [structured data](https://moz.com/learn/seo/schema-structured-data) extraction tool written in Elixir.\n\nIt currently supports unfurling oEmbed, Open Graph (Facebook), Twitter Card, JSON-LD, rel-me, favicons, and plain ole' HTML ` ` data out of any url you supply.","ref":"readme.html"},{"type":"extras","title":"Installation - Unfurl","doc":"Add `:unfurl` to your list of dependencies in `mix.exs`:O\n\n```elixir\ndef deps do\n  [{:unfurl, \"~> 0.6.0\"}]\nend\n```\n\nThen run `$ mix deps.get`. Also add `:unfurl` to your applications list:\n\n```elixir\ndef application do\n  [applications: [:unfurl]]\nend\n```\n\n[Jason](http://github.com/michalmuskala/jason) is the default json library in Unfurl. You can however configure Unfurl to use another library. For example:\n\n```elixir\nconfig :unfurl, :json_library, YourLibraryOfChoice\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Unfurl","doc":"To unfurl a url, simply pass it to `Unfurl.unfurl/1`\n\n```elixir\niex(1)> Unfurl.unfurl \"https://www.youtube.com/watch?v=Gh6H7Md_L2k\"\n{:ok,\n %{\n   other: %{\n     \"description\" => \"Ask This Old House host Kevin O’Connor visits Nick Offerman in Los Angeles to tour the comedian’s woodworking shop.SUBSCRIBE to This Old House: http://bit.ly...\",\n     \"keywords\" => \"this old house, how-to, home improvement, Episode, TV Show, DIY, Ask This Old House, Nick Offerman, Kevin O'Connor, woodworking, wood shop, Los Angeles, Comedian, This Old House, Home Improvement, DIY Ideas, Renovation, Renovation Ideas, How To Fix, How To Install, How To Build, Kevin o’connor, kevin o'connor house, kevin o'connor this old house, kevin o'connor ask this old house, kevin o'connor interview\",\n     \"theme-color\" => \"rgba(255, 255, 255, 0.98)\",\n     \"title\" => [\"Touring Nick Offerman’s Wood Shop | Ask This Old House\",\n      \"Touring Nick Offerman’s Wood Shop | Ask This Old House - YouTube\"]\n   },\n   canonical_url: nil,\n   facebook: %{\n     \"description\" => \"Ask This Old House host Kevin O’Connor visits Nick Offerman in Los Angeles to tour the comedian’s woodworking shop.SUBSCRIBE to This Old House: http://bit.ly...\",\n     \"fb\" => %{\"app_id\" => \"87741124305\"},\n     \"image\" => %{\"height\" => \"720\", \"width\" => \"1280\"},\n     \"site_name\" => \"YouTube\",\n     \"title\" => \"Touring Nick Offerman’s Wood Shop | Ask This Old House\",\n     \"type\" => \"video.other\",\n     \"url\" => \"https://www.youtube.com/watch?v=Gh6H7Md_L2k\",\n     \"video\" => %{\n       \"height\" => \"720\",\n       \"secure_url\" => \"https://www.youtube.com/embed/Gh6H7Md_L2k\",\n       \"type\" => \"text/html\",\n       \"url\" => \"https://www.youtube.com/embed/Gh6H7Md_L2k\",\n       \"width\" => \"1280\"\n     }\n   },\n   twitter: %{\n     \"app\" => %{\n       \"id\" => %{\n         \"googleplay\" => \"com.google.android.youtube\",\n         \"ipad\" => \"544007664\",\n         \"iphone\" => \"544007664\"\n       },\n       \"name\" => %{\n         \"googleplay\" => \"YouTube\",\n         \"ipad\" => \"YouTube\",\n         \"iphone\" => \"YouTube\"\n       },\n       \"url\" => %{\n         \"googleplay\" => \"https://www.youtube.com/watch?v=Gh6H7Md_L2k\",\n         \"ipad\" => \"vnd.youtube://www.youtube.com/watch?v=Gh6H7Md_L2k&feature=applinks\",\n         \"iphone\" => \"vnd.youtube://www.youtube.com/watch?v=Gh6H7Md_L2k&feature=applinks\"\n       }\n     },\n     \"card\" => \"player\",\n     \"description\" => \"Ask This Old House host Kevin O’Connor visits Nick Offerman in Los Angeles to tour the comedian’s woodworking shop.SUBSCRIBE to This Old House: http://bit.ly...\",\n     \"image\" => \"https://i.ytimg.com/vi/Gh6H7Md_L2k/maxresdefault.jpg\",\n     \"player\" => %{\"height\" => \"720\", \"width\" => \"1280\"},\n     \"site\" => \"@youtube\",\n     \"title\" => \"Touring Nick Offerman’s Wood Shop | Ask This Old House\",\n     \"url\" => \"https://www.youtube.com/watch?v=Gh6H7Md_L2k\"\n   },\n   oembed: %{\n     \"author_name\" => \"This Old House\",\n     \"author_url\" => \"https://www.youtube.com/@thisoldhouse\",\n     \"height\" => 113,\n     \"html\" => \"  \",\n     \"provider_name\" => \"YouTube\",\n     \"provider_url\" => \"https://www.youtube.com/\",\n     \"thumbnail_height\" => 360,\n     \"thumbnail_url\" => \"https://i.ytimg.com/vi/Gh6H7Md_L2k/hqdefault.jpg\",\n     \"thumbnail_width\" => 480,\n     \"title\" => \"Touring Nick Offerman’s Wood Shop | Ask This Old House\",\n     \"type\" => \"video\",\n     \"version\" => \"1.0\",\n     \"width\" => 200\n   },\n   json_ld: [\n     %{\n       \"@context\" => \"http://schema.org\",\n       \"@type\" => \"BreadcrumbList\",\n       \"itemListElement\" => [\n         %{\n           \"@type\" => \"ListItem\",\n           \"item\" => %{\n             \"@id\" => \"http://www.youtube.com/@thisoldhouse\",\n             \"name\" => \"This Old House\"\n           },\n           \"position\" => 1\n         }\n       ]\n     }\n   ],\n   status_code: 200,\n   rel_me: nil,\n   favicon: \"https://www.youtube.com/s/desktop/ef8ce500/img/favicon_32x32.png\"\n }}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - Unfurl","doc":"Unfurl accepts a few optional configuration parameters.\n\nYou may configure additional tags to capture under the Facebook\nOpenGraph and TwitterCard parsers.\n\n```elixir\nconfig :unfurl, Unfurl.Parser.Facebook,\n  tags: ~w(my:custom:facebook:tag another:custom:facebook:tag)\n\nconfig :unfurl, Unfurl.Parser.Twitter,\n  tags: ~w(my:custom:twitter:tag)\n```\n\nYou may also configure the depth of the resulting Unfurl map with a `:group_keys?` boolean.\n\n```elixir\nconfig :unfurl, group_keys?: true\n```\n\nIf this option is set to false or unconfigured, Unfurl will return values mapped directly beneath OpenGraph and TwitterCard keys, i.e.\n\n```elixir\n%{twitter: %{\n  \"twitter:app:id:googleplay\" => \"com.google.android.youtube\",\n  \"twitter:app:id:ipad\"       => \"544007664\",\n  \"twitter:app:id:iphone\"     => \"544007664\"\n}}\n```\n\nIf true, Unfurl will return values grouped into colon-delimited map structures, i.e.\n\n```elixir\n%{twitter: %{\n  \"twitter\" => %{\n    \"app\" => %{\n      \"id\" => %{\n        \"googleplay\" => \"com.google.android.youtube\",\n        \"ipad\"       => \"544007664\",\n        \"iphone\"     => \"544007664\"\n      }\n    }\n  }\n}}\n```","ref":"readme.html#configuration"},{"type":"extras","title":"License - Unfurl","doc":"Copyright 2020 Bonfire Networks\nCopyright 2017 Clayton Gentry (author of https://www.hex.pm/packages/furlex which Unfurl was forked from)\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n```\nhttp://www.apache.org/licenses/LICENSE-2.0`\n```\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v.0.6.0 - Changelog","doc":"Forked from Furlex with many changes/additions - changelog TODO","ref":"changelog.html#v-0-6-0"},{"type":"extras","title":"v.0.5.0 - Changelog","doc":"- Updates Floki ([queer](https://github.com/queer))\n- Conforms code style to `mix format` ([queer](https://github.com/queer))","ref":"changelog.html#v-0-5-0"},{"type":"extras","title":"v.0.4.3 - Changelog","doc":"- Relaxes cowboy dependency ([abitdodgy](https://github.com/abitdodgy))","ref":"changelog.html#v-0-4-3"},{"type":"extras","title":"v.0.4.2 - Changelog","doc":"- Don't require oembed host configuration","ref":"changelog.html#v-0-4-2"},{"type":"extras","title":"v.0.4.1 - Changelog","doc":"- Various dependency updates","ref":"changelog.html#v-0-4-1"},{"type":"extras","title":"v.0.4.0 - Changelog","doc":"- Make json library configurable, default to Jason ([abitdodgy](https://github.com/abitdodgy))\n- Bump HTTPoison to 1.5 ([abitdodgy](https://github.com/abitdodgy))","ref":"changelog.html#v-0-4-0"},{"type":"extras","title":"v.0.3.3 - Changelog","doc":"- Supports fetch options passed through unfurl (thanks [aliou](https://github.com/aliou)!)","ref":"changelog.html#v-0-3-3"},{"type":"extras","title":"v.0.3.2 - Changelog","doc":"- Remove usage of Mix.env() for segmenting app logic. Instead, leverage test bypasses where needed (h/t [Luciam91](https://github.com/Luciam91))\n- Strip out needless cruft from test fixtures.","ref":"changelog.html#v-0-3-2"},{"type":"extras","title":"v.0.3.1 - Changelog","doc":"- Fix handling of duplicate HTML meta tags","ref":"changelog.html#v-0-3-1"},{"type":"extras","title":"v.0.3.0 - Changelog","doc":"- Individual fetch and parse operations now run asynchronously","ref":"changelog.html#v-0-3-0"},{"type":"extras","title":"v.0.2.2 - Changelog","doc":"- Unfurl now supports passing HTTP options to Unfurl.unfurl/2.\n- `:depth` config has been transformed to a `:group_keys?` boolean.","ref":"changelog.html#v-0-2-2"},{"type":"extras","title":"v.0.2.1 - Changelog","doc":"- Add status code to Unfurl's return (thanks [abitdodgy](https://github.com/abitdodgy))\n- Fix compatibility with Phoenix 1.3 (thanks, again, [abitdodgy](https://github.com/abitdodgy)!)","ref":"changelog.html#v-0-2-1"},{"type":"extras","title":"v.0.2.0 - Changelog","doc":"- Support configuration for grouping colon-delimited keys into map structures\n- Don't require explicitly configuring OpenGraph and TwitterCard tags in your app config.\n- Enable adding custom tags under OpenGraph and TwitterCard parsers.","ref":"changelog.html#v-0-2-0"},{"type":"extras","title":"v.0.1.3 - Changelog","doc":"- Add typespecs, better examples to documentation","ref":"changelog.html#v-0-1-3"},{"type":"extras","title":"v.0.1.2 - Changelog","doc":"- Parse colon-separated OpenGraph and Twitter Card keywords into map structures\n  - E.g. %{\"twitter:app:id\" => 123} becomes %{\"twitter\" => %{\"app\" => %{\"id\" => 123}}}","ref":"changelog.html#v-0-1-2"},{"type":"extras","title":"v.0.1.1 - Changelog","doc":"- Fix test-breaking bug when included as hex dependency\n- Add tags","ref":"changelog.html#v-0-1-1"},{"type":"extras","title":"v.0.1.0 - Changelog","doc":"- Support unfurling oEmbed, Facebook Open Graph, Twitter Card, JSON-LD and other HTML meta tags.\n- Extract canonical urls","ref":"changelog.html#v-0-1-0"}],"content_type":"text/markdown"}